Subject: Human-readable Time Specifications for the Schedule MIB

From: Frank Strauss <[email-masked]>
Date: 16 Mar 2001 16:10:46 +0100

Hi!

While we have implemented a Schedule MIB agent and a DISMAN manager
application that interacts with Schedule MIB agents, we stumbled over
the question how to represent the calendar time specifications of
the Schedule MIB in a handy and intuitive fashion to the user. We've
developed a simple grammar for such time specifications, that we
have implemented for configuration files of the agent and for user
dialogs at the manager.

Since, we are probably not the only people that had to think about
this question, I have written down our specification as an I-D.
Any comments are welcome.

 -frank

Network Working Group                                         F. Strauss
Internet-Draft                                           TU Braunschweig
Expires: September 13, 2001                               March 15, 2001

        Human-readable Time Specifications for the Schedule MIB
                draft-strauss-disman-sched-timespecs-00

Status of this Memo

   This document is an Internet-Draft and is in full conformance with
   all provisions of Section 10 of RFC2026.

   Internet-Drafts are working documents of the Internet Engineering
   Task Force (IETF), its areas, and its working groups.  Note that
   other groups may also distribute working documents as Internet-
   Drafts.

   Internet-Drafts are draft documents valid for a maximum of six months
   and may be updated, replaced, or obsoleted by other documents at any
   time.  It is inappropriate to use Internet-Drafts as reference
   material or to cite them other than as "work in progress."

   The list of current Internet-Drafts can be accessed at
   http://www.ietf.org/ietf/1id-abstracts.txt.

   The list of Internet-Draft Shadow Directories can be accessed at
   http://www.ietf.org/shadow.html.

   This Internet-Draft will expire on September 13, 2001.

Copyright Notice

   Copyright (C) The Internet Society (2001).  All Rights Reserved.

Abstract

   The Schedule MIB [RFC2591] defines a mechanism to launch actions on a
   regular basis or at specific calendar-based times.  When the time
   specifications of the Schedule MIB have to be represented at a user
   interface or in configuration files, a handy human-readable
   representation becomes desirable.  This memo presents such a human-
   readable representation of time specifications for the Schedule MIB.

Strauss                Expires September 13, 2001               [Page 1]

Internet-Draft           Schedule MIB Time Specs              March 2001

Table of Contents

   1. Introduction . . . . . . . . . . . . . . . . . . . . . . . . . . 3
   2. Grammar and Semantics  . . . . . . . . . . . . . . . . . . . . . 3
   3. Examples . . . . . . . . . . . . . . . . . . . . . . . . . . . . 5
   4. Security Considerations  . . . . . . . . . . . . . . . . . . . . 5
      References . . . . . . . . . . . . . . . . . . . . . . . . . . . 5
      Author's Address . . . . . . . . . . . . . . . . . . . . . . . . 5
   A. OPEN ISSUES  . . . . . . . . . . . . . . . . . . . . . . . . . . 6
      Full Copyright Statement . . . . . . . . . . . . . . . . . . . . 7

Strauss                Expires September 13, 2001               [Page 2]

Internet-Draft           Schedule MIB Time Specs              March 2001

1. Introduction

   The reader of this document is expected to be familiar with the
   Schedule MIB [RFC2591].

   The Schedule MIB time specifications of periodic and calendar/oneshot
   schedule are stored in seven columnar objects: schedType denotes the
   type of the schedule, either periodic, calendar or oneshot.
   Depending on this value either the schedInterval object is meaningful
   in case of a periodic schedule, or the five objects schedWeekDay,
   schedMonth, schedDay, schedHour, and schedMinute in case of calendar
   and oneshot schedules.  While this is a reasonable and very flexible
   way to express schedule time specifications in the MIB, it is not
   that convenient to use these seven attributes when interacting with a
   user.

   This document presents a simple grammar for representing Schedule MIB
   time specifications with the following goals:

   o  Narrow Representation: In almost any case, the representation of a
      schedule time specification shall take little space when presented
      at a user interface.

   o  Handy Representation: The whole specification should be more handy
      than a collection of six or seven attributes.

   o  Human Readability: The representation should be human readable.

   o  Avoiding Typical Misinterpretations: Typical mistakes that humans
      run into should be avoided by the representation, e.g.: when no
      bits in one of the calendar objects are set in the MIB, this means
      that the schedule gets never invoked.  However when a user does
      not specify a calendar attribute, he usually wishes this attribute
      to be a `match-any'.

   o  Implementation Costs: It should be easy to implement a simple
      parser that reads time specifications entered by a user or read
      from a configuration.  Similarly, it should be easy to render MIB
      information according to the proposed representation.

2. Grammar and Semantics

   Based on the goals described in the former section, this memo
   proposes to represent a schedule time specification as a single
   string that complies to the following grammar:

Strauss                Expires September 13, 2001               [Page 3]

Internet-Draft           Schedule MIB Time Specs              March 2001

     spec    = number | "" | "*" | list

     list    = item [ " " item ]*

     item    = start [ "/" step ] |
               range [ "/" step ]

     start   = witem mitem ditem ritem Hitem Mitem

     range   = witem "-" witem | mitem "-" mitem |
               ditem "-" ditem | ritem "-" ritem |
               Hitem "-" Hitem | Mitem "-" Mitem

     step    = number

     witem   = "mon" | "tue" | "wed" | "thu" |
               "fri" | "sat" | "sun"

     ditem   = "d1" .. "d31"

     ritem   = "r1" .. "r31"

     mitem   = "jan" | "feb" | "mar" | "apr" | "may" | "jun" |
               "jul" | "aug" | "sep" | "oct" | "nov" | "dec"

     Hitem   = "h0" .. "h23"

     Mitem   = "m0" .. "m59"

   A single (unsigned) integer number specifies the interval of a
   periodic schedule.

   An empty string specifies a calendar/oneshot schedule that matches no
   point in time.

   An "*" string specifies a calendar/oneshot schedule that matches any
   minute, i.e., all bits in the 5 BITS objects are set (exception: not
   all of the schedDay d*/r* bits have to be set to achieve this).

   Any other string has to represent a list of items separated by single
   blanks.  Each item has to consist of a mandatory start value, an
   optional end value (separated by `-') and an optional step value
   (separated by `/').  Start and end values can be weekdays, months,
   `d-days', `r-days', hours, or minutes and must be of the same type
   and in low-high order when both are present in a single item.  Step
   values are unsigned integers >= 1.  If an end value is given but no
   step value, the step is 1.  If a step value is given but no end

Strauss                Expires September 13, 2001               [Page 4]

Internet-Draft           Schedule MIB Time Specs              March 2001

   value, the end value is the last possible value of the given type.
   If both, end and step value, are omitted, the item represents only a
   single value.  All letters in the values are case-sensitive and must
   be lowercase.  No intermediate blanks are allowed, except for
   separating items.

   Note that calendar and oneshot schedules cannot be distinguished by
   this grammar.

3. Examples

     ""                       never
     "*"                      each and every minute
     "30"                     periodically every 30 seconds
     "mon-fri h12 m0"         each monday to friday at 12 o'clock
     "mar/3 r1 h23 m59"       each quarter's last day at 23:59
     "mon-fri/2 h8-18 m0/30"  every 30 minutes from 8:00 to 18:30
                              on each monday, wednesday, and friday

4. Security Considerations

   This document defines a string representation of schedule time
   specifications which has no security impact on the Internet.

References

   [RFC2591]  Levi, D. and J. Schoenwaelder, "Definitions of Managed
              Objects for Scheduling Management Operations", RFC 2591,
              May 1999.

Author's Address

   Frank Strauss
   TU Braunschweig
   Bueltenweg 74/75
   38106 Braunschweig
   Germany

   Phone: +49 531 391-3266
   EMail: [email-masked]
   URI:   http://www.ibr.cs.tu-bs.de/

Strauss                Expires September 13, 2001               [Page 5]

Internet-Draft           Schedule MIB Time Specs              March 2001

Appendix A. OPEN ISSUES

   1.  People might expect something like "mon-fri" to fire _once_ each
       workday?! Should defaults for hour and minute be `0' instead of
       `any' There might be other intuitively varying situations.

   2.  Do we need a way to express whether its a calendar or oneshot
       schedule?

   3.  Do we need words on error handling?

Strauss                Expires September 13, 2001               [Page 6]

Internet-Draft           Schedule MIB Time Specs              March 2001

Full Copyright Statement

   Copyright (C) The Internet Society (2001).  All Rights Reserved.

   This document and translations of it may be copied and furnished to
   others, and derivative works that comment on or otherwise explain it
   or assist in its implementation may be prepared, copied, published
   and distributed, in whole or in part, without restriction of any
   kind, provided that the above copyright notice and this paragraph are
   included on all such copies and derivative works.  However, this
   document itself may not be modified in any way, such as by removing
   the copyright notice or references to the Internet Society or other
   Internet organizations, except as needed for the purpose of
   developing Internet standards in which case the procedures for
   copyrights defined in the Internet Standards process must be
   followed, or as required to translate it into languages other than
   English.

   The limited permissions granted above are perpetual and will not be
   revoked by the Internet Society or its successors or assigns.

   This document and the information contained herein is provided on an
   "AS IS" basis and THE INTERNET SOCIETY AND THE INTERNET ENGINEERING
   TASK FORCE DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING
   BUT NOT LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION
   HEREIN WILL NOT INFRINGE ANY RIGHTS OR ANY IMPLIED WARRANTIES OF
   MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

Acknowledgement

   Funding for the RFC Editor function is currently provided by the
   Internet Society.

Strauss                Expires September 13, 2001               [Page 7]

---

From: Randy Presuhn <[email-masked]>
Date: Thu, 29 Mar 2001 09:28:48 -0800 (PST)

Hi -

I'm forwarding a non-subscriber posting to the disman WG mailing list.
I've added <[email-masked]> to the disman "posters" list.

|Received: from tattler.bmc.com (tattler.bmc.com [172.17.0.117])
|	by dorothy.bmc.com (8.8.6 (PHNE_12836)/8.8.6) with ESMTP id HAA14814
|	for <[email-masked]>; Thu, 29 Mar 2001 07:31:51 -0800 (PST)
|Received: from fw-us-hou-9.bmc.com (fw-us-hou1.bmc.com [172.17.0.250])
|	by tattler.bmc.com (8.10.2/8.10.2) with SMTP id f2TFTuH27354
|	for <[email-masked]>; Thu, 29 Mar 2001 09:29:56 -0600 (CST)
|Received: from ctron-dnm.cabletron.com ([12.25.1.120]) by fw-us-hou-9.bmc.com; Thu, 29 Mar 2001 09:32:52 +0000 (CST)
|Received: (from uucp@localhost)
|	by ctron-dnm.ctron.com (8.8.7/8.8.7) id KAA18423;
|	Thu, 29 Mar 2001 10:37:40 -0500 (EST)
|Received: from cnc-exc2.ctron.com(134.141.77.103) by ctron-dnm.ctron.com via smap (4.1)
|	id xma018388; Thu, 29 Mar 01 10:36:46 -0500
|Received: by cnc-exc2.ctron.com with Internet Mail Service (5.5.2650.21)
|	id <HZJS566L>; Thu, 29 Mar 2001 10:30:17 -0500
|Message-ID: <[email-masked]>
|From: "Norseth, KC" <[email-masked]>
|To: "'Frank Strauss'" <[email-masked]>, [email-masked]
|Subject: RE: Human-readable Time Specifications for the Schedule MIB
|Date: Thu, 29 Mar 2001 10:30:18 -0500
|MIME-Version: 1.0
|X-Mailer: Internet Mail Service (5.5.2650.21)
|Content-Type: multipart/alternative;
|	boundary="----_=_NextPart_001_01C0B865.2802136A"
|
|This message is in MIME format. Since your mail reader does not understand
|this format, some or all of this message may not be legible.
|
|------_=_NextPart_001_01C0B865.2802136A
|Content-Type: text/plain;
|	charset="iso-8859-1"
|
|Frank,
|
|Sorry I was not able to get to this document sooner.
|
|A couple of things:
|In your example, how does this work?  
|
|     "mar/3 r1 h23 m59"       each quarter's last day at 23:59
|
|I was trying to figure out how this text broke out and what some of the
|terms meant like ritem meant.  Most of the grammar was easy to figure out
|but maybe a little more documentation would help out.
|
|Is this draft available online?
|
|K.C.
|
|-----Original Message-----
|From: Frank Strauss [mailto:[email-masked]]
|Sent: Friday, March 16, 2001 8:11 AM
|To: [email-masked]
|Subject: Human-readable Time Specifications for the Schedule MIB
|
|
|
|Hi!
|
|While we have implemented a Schedule MIB agent and a DISMAN manager
|application that interacts with Schedule MIB agents, we stumbled over
|the question how to represent the calendar time specifications of
|the Schedule MIB in a handy and intuitive fashion to the user. We've
|developed a simple grammar for such time specifications, that we
|have implemented for configuration files of the agent and for user
|dialogs at the manager.
|
|Since, we are probably not the only people that had to think about
|this question, I have written down our specification as an I-D.
|Any comments are welcome.
|
| -frank
|
|
|
|Network Working Group                                         F. Strauss
|Internet-Draft                                           TU Braunschweig
|Expires: September 13, 2001                               March 15, 2001
|
|
|        Human-readable Time Specifications for the Schedule MIB
|                draft-strauss-disman-sched-timespecs-00
|
|Status of this Memo
|
|   This document is an Internet-Draft and is in full conformance with
|   all provisions of Section 10 of RFC2026.
|
|   Internet-Drafts are working documents of the Internet Engineering
|   Task Force (IETF), its areas, and its working groups.  Note that
|   other groups may also distribute working documents as Internet-
|   Drafts.
|
|   Internet-Drafts are draft documents valid for a maximum of six months
|   and may be updated, replaced, or obsoleted by other documents at any
|   time.  It is inappropriate to use Internet-Drafts as reference
|   material or to cite them other than as "work in progress."
|
|   The list of current Internet-Drafts can be accessed at
|   http://www.ietf.org/ietf/1id-abstracts.txt.
|
|   The list of Internet-Draft Shadow Directories can be accessed at
|   http://www.ietf.org/shadow.html.
|
|   This Internet-Draft will expire on September 13, 2001.
|
|Copyright Notice
|
|   Copyright (C) The Internet Society (2001).  All Rights Reserved.
|
|Abstract
|
|   The Schedule MIB [RFC2591] defines a mechanism to launch actions on a
|   regular basis or at specific calendar-based times.  When the time
|   specifications of the Schedule MIB have to be represented at a user
|   interface or in configuration files, a handy human-readable
|   representation becomes desirable.  This memo presents such a human-
|   readable representation of time specifications for the Schedule MIB.
|
|
|
|
|
|
|
|
|
|Strauss                Expires September 13, 2001               [Page 1]
|
|
|Internet-Draft           Schedule MIB Time Specs              March 2001
|
|
|Table of Contents
|
|   1. Introduction . . . . . . . . . . . . . . . . . . . . . . . . . . 3
|   2. Grammar and Semantics  . . . . . . . . . . . . . . . . . . . . . 3
|   3. Examples . . . . . . . . . . . . . . . . . . . . . . . . . . . . 5
|   4. Security Considerations  . . . . . . . . . . . . . . . . . . . . 5
|      References . . . . . . . . . . . . . . . . . . . . . . . . . . . 5
|      Author's Address . . . . . . . . . . . . . . . . . . . . . . . . 5
|   A. OPEN ISSUES  . . . . . . . . . . . . . . . . . . . . . . . . . . 6
|      Full Copyright Statement . . . . . . . . . . . . . . . . . . . . 7
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|Strauss                Expires September 13, 2001               [Page 2]
|
|
|Internet-Draft           Schedule MIB Time Specs              March 2001
|
|
|1. Introduction
|
|   The reader of this document is expected to be familiar with the
|   Schedule MIB [RFC2591].
|
|   The Schedule MIB time specifications of periodic and calendar/oneshot
|   schedule are stored in seven columnar objects: schedType denotes the
|   type of the schedule, either periodic, calendar or oneshot.
|   Depending on this value either the schedInterval object is meaningful
|   in case of a periodic schedule, or the five objects schedWeekDay,
|   schedMonth, schedDay, schedHour, and schedMinute in case of calendar
|   and oneshot schedules.  While this is a reasonable and very flexible
|   way to express schedule time specifications in the MIB, it is not
|   that convenient to use these seven attributes when interacting with a
|   user.
|
|   This document presents a simple grammar for representing Schedule MIB
|   time specifications with the following goals:
|
|   o  Narrow Representation: In almost any case, the representation of a
|      schedule time specification shall take little space when presented
|      at a user interface.
|
|   o  Handy Representation: The whole specification should be more handy
|      than a collection of six or seven attributes.
|
|   o  Human Readability: The representation should be human readable.
|
|   o  Avoiding Typical Misinterpretations: Typical mistakes that humans
|      run into should be avoided by the representation, e.g.: when no
|      bits in one of the calendar objects are set in the MIB, this means
|      that the schedule gets never invoked.  However when a user does
|      not specify a calendar attribute, he usually wishes this attribute
|      to be a `match-any'.
|
|   o  Implementation Costs: It should be easy to implement a simple
|      parser that reads time specifications entered by a user or read
|      from a configuration.  Similarly, it should be easy to render MIB
|      information according to the proposed representation.
|
|
|2. Grammar and Semantics
|
|   Based on the goals described in the former section, this memo
|   proposes to represent a schedule time specification as a single
|   string that complies to the following grammar:
|
|
|
|
|
|Strauss                Expires September 13, 2001               [Page 3]
|
|
|Internet-Draft           Schedule MIB Time Specs              March 2001
|
|
|     spec    = number | "" | "*" | list
|
|     list    = item [ " " item ]*
|
|     item    = start [ "/" step ] |
|               range [ "/" step ]
|
|     start   = witem mitem ditem ritem Hitem Mitem
|
|     range   = witem "-" witem | mitem "-" mitem |
|               ditem "-" ditem | ritem "-" ritem |
|               Hitem "-" Hitem | Mitem "-" Mitem
|
|     step    = number
|
|     witem   = "mon" | "tue" | "wed" | "thu" |
|               "fri" | "sat" | "sun"
|
|     ditem   = "d1" .. "d31"
|
|     ritem   = "r1" .. "r31"
|
|     mitem   = "jan" | "feb" | "mar" | "apr" | "may" | "jun" |
|               "jul" | "aug" | "sep" | "oct" | "nov" | "dec"
|
|     Hitem   = "h0" .. "h23"
|
|     Mitem   = "m0" .. "m59"
|
|
|   A single (unsigned) integer number specifies the interval of a
|   periodic schedule.
|
|   An empty string specifies a calendar/oneshot schedule that matches no
|   point in time.
|
|   An "*" string specifies a calendar/oneshot schedule that matches any
|   minute, i.e., all bits in the 5 BITS objects are set (exception: not
|   all of the schedDay d*/r* bits have to be set to achieve this).
|
|   Any other string has to represent a list of items separated by single
|   blanks.  Each item has to consist of a mandatory start value, an
|   optional end value (separated by `-') and an optional step value
|   (separated by `/').  Start and end values can be weekdays, months,
|   `d-days', `r-days', hours, or minutes and must be of the same type
|   and in low-high order when both are present in a single item.  Step
|   values are unsigned integers >= 1.  If an end value is given but no
|   step value, the step is 1.  If a step value is given but no end
|
|
|
|Strauss                Expires September 13, 2001               [Page 4]
|
|
|Internet-Draft           Schedule MIB Time Specs              March 2001
|
|
|   value, the end value is the last possible value of the given type.
|   If both, end and step value, are omitted, the item represents only a
|   single value.  All letters in the values are case-sensitive and must
|   be lowercase.  No intermediate blanks are allowed, except for
|   separating items.
|
|   Note that calendar and oneshot schedules cannot be distinguished by
|   this grammar.
|
|3. Examples
|
|
|
|     ""                       never
|     "*"                      each and every minute
|     "30"                     periodically every 30 seconds
|     "mon-fri h12 m0"         each monday to friday at 12 o'clock
|     "mar/3 r1 h23 m59"       each quarter's last day at 23:59
|     "mon-fri/2 h8-18 m0/30"  every 30 minutes from 8:00 to 18:30
|                              on each monday, wednesday, and friday
|
|
|
|4. Security Considerations
|
|   This document defines a string representation of schedule time
|   specifications which has no security impact on the Internet.
|
|References
|
|   [RFC2591]  Levi, D. and J. Schoenwaelder, "Definitions of Managed
|              Objects for Scheduling Management Operations", RFC 2591,
|              May 1999.
|
|
|Author's Address
|
|   Frank Strauss
|   TU Braunschweig
|   Bueltenweg 74/75
|   38106 Braunschweig
|   Germany
|
|   Phone: +49 531 391-3266
|   EMail: [email-masked]
|   URI:   http://www.ibr.cs.tu-bs.de/
|
|
|
|
|
|Strauss                Expires September 13, 2001               [Page 5]
|
|
|Internet-Draft           Schedule MIB Time Specs              March 2001
|
|
|Appendix A. OPEN ISSUES
|
|   1.  People might expect something like "mon-fri" to fire _once_ each
|       workday?! Should defaults for hour and minute be `0' instead of
|       `any' There might be other intuitively varying situations.
|
|   2.  Do we need a way to express whether its a calendar or oneshot
|       schedule?
|
|   3.  Do we need words on error handling?
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|Strauss                Expires September 13, 2001               [Page 6]
|
|
|Internet-Draft           Schedule MIB Time Specs              March 2001
|
|
|Full Copyright Statement
|
|   Copyright (C) The Internet Society (2001).  All Rights Reserved.
|
|   This document and translations of it may be copied and furnished to
|   others, and derivative works that comment on or otherwise explain it
|   or assist in its implementation may be prepared, copied, published
|   and distributed, in whole or in part, without restriction of any
|   kind, provided that the above copyright notice and this paragraph are
|   included on all such copies and derivative works.  However, this
|   document itself may not be modified in any way, such as by removing
|   the copyright notice or references to the Internet Society or other
|   Internet organizations, except as needed for the purpose of
|   developing Internet standards in which case the procedures for
|   copyrights defined in the Internet Standards process must be
|   followed, or as required to translate it into languages other than
|   English.
|
|   The limited permissions granted above are perpetual and will not be
|   revoked by the Internet Society or its successors or assigns.
|
|   This document and the information contained herein is provided on an
|   "AS IS" basis and THE INTERNET SOCIETY AND THE INTERNET ENGINEERING
|   TASK FORCE DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING
|   BUT NOT LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION
|   HEREIN WILL NOT INFRINGE ANY RIGHTS OR ANY IMPLIED WARRANTIES OF
|   MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
|
|Acknowledgement
|
|   Funding for the RFC Editor function is currently provided by the
|   Internet Society.
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|Strauss                Expires September 13, 2001               [Page 7]
|
|
|
|------_=_NextPart_001_01C0B865.2802136A
|Content-Type: text/html;
|	charset="iso-8859-1"
|Content-Transfer-Encoding: quoted-printable
|
|<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
|<HTML>
|<HEAD>
|<META HTTP-EQUIV=3D"Content-Type" CONTENT=3D"text/html; =
|charset=3Diso-8859-1">
|<META NAME=3D"Generator" CONTENT=3D"MS Exchange Server version =
|5.5.2650.12">
|<TITLE>RE: Human-readable Time Specifications for the Schedule =
|MIB</TITLE>
|</HEAD>
|<BODY>
|
|<P><FONT SIZE=3D2>Frank,</FONT>
|</P>
|
|<P><FONT SIZE=3D2>Sorry I was not able to get to this document =
|sooner.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>A couple of things:</FONT>
|<BR><FONT SIZE=3D2>In your example, how does this work?&nbsp; </FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; &quot;mar/3 r1 h23 =
|m59&quot;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; each quarter's last day =
|at 23:59</FONT>
|</P>
|
|<P><FONT SIZE=3D2>I was trying to figure out how this text broke out =
|and what some of the terms meant like ritem meant.&nbsp; Most of the =
|grammar was easy to figure out but maybe a little more documentation =
|would help out.</FONT></P>
|
|<P><FONT SIZE=3D2>Is this draft available online?</FONT>
|</P>
|
|<P><FONT SIZE=3D2>K.C.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>-----Original Message-----</FONT>
|<BR><FONT SIZE=3D2>From: Frank Strauss [<A =
|HREF=3D"mailto:[email-masked]">mailto:[email-masked]</=
|A>]</FONT>
|<BR><FONT SIZE=3D2>Sent: Friday, March 16, 2001 8:11 AM</FONT>
|<BR><FONT SIZE=3D2>To: [email-masked]</FONT>
|<BR><FONT SIZE=3D2>Subject: Human-readable Time Specifications for the =
|Schedule MIB</FONT>
|</P>
|<BR>
|<BR>
|
|<P><FONT SIZE=3D2>Hi!</FONT>
|</P>
|
|<P><FONT SIZE=3D2>While we have implemented a Schedule MIB agent and a =
|DISMAN manager</FONT>
|<BR><FONT SIZE=3D2>application that interacts with Schedule MIB agents, =
|we stumbled over</FONT>
|<BR><FONT SIZE=3D2>the question how to represent the calendar time =
|specifications of</FONT>
|<BR><FONT SIZE=3D2>the Schedule MIB in a handy and intuitive fashion to =
|the user. We've</FONT>
|<BR><FONT SIZE=3D2>developed a simple grammar for such time =
|specifications, that we</FONT>
|<BR><FONT SIZE=3D2>have implemented for configuration files of the =
|agent and for user</FONT>
|<BR><FONT SIZE=3D2>dialogs at the manager.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>Since, we are probably not the only people that had =
|to think about</FONT>
|<BR><FONT SIZE=3D2>this question, I have written down our specification =
|as an I-D.</FONT>
|<BR><FONT SIZE=3D2>Any comments are welcome.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;-frank</FONT>
|</P>
|<BR>
|<BR>
|
|<P><FONT SIZE=3D2>Network Working =
|Group&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp;&nbsp;&nbsp;&nbsp; F. Strauss</FONT>
|<BR><FONT =
|SIZE=3D2>Internet-Draft&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; TU =
|Braunschweig</FONT>
|<BR><FONT SIZE=3D2>Expires: September 13, =
|2001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; March 15, 2001</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
|Human-readable Time Specifications for the Schedule MIB</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp;&nbsp;&nbsp; =
|draft-strauss-disman-sched-timespecs-00</FONT>
|</P>
|
|<P><FONT SIZE=3D2>Status of this Memo</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; This document is an Internet-Draft and =
|is in full conformance with</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; all provisions of Section 10 of =
|RFC2026.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Internet-Drafts are working documents of =
|the Internet Engineering</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; Task Force (IETF), its areas, and its =
|working groups.&nbsp; Note that</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; other groups may also distribute =
|working documents as Internet-</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; Drafts.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Internet-Drafts are draft documents =
|valid for a maximum of six months</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; and may be updated, replaced, or =
|obsoleted by other documents at any</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; time.&nbsp; It is inappropriate to use =
|Internet-Drafts as reference</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; material or to cite them other than as =
|&quot;work in progress.&quot;</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; The list of current Internet-Drafts can =
|be accessed at</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; <A =
|HREF=3D"http://www.ietf.org/ietf/1id-abstracts.txt" =
|TARGET=3D"_blank">http://www.ietf.org/ietf/1id-abstracts.txt</A>.</FONT>=
|
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; The list of Internet-Draft Shadow =
|Directories can be accessed at</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; <A =
|HREF=3D"http://www.ietf.org/shadow.html" =
|TARGET=3D"_blank">http://www.ietf.org/shadow.html</A>.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; This Internet-Draft will expire on =
|September 13, 2001.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>Copyright Notice</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Copyright (C) The Internet Society =
|(2001).&nbsp; All Rights Reserved.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>Abstract</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; The Schedule MIB [RFC2591] defines a =
|mechanism to launch actions on a</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; regular basis or at specific =
|calendar-based times.&nbsp; When the time</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; specifications of the Schedule MIB have =
|to be represented at a user</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; interface or in configuration files, a =
|handy human-readable</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; representation becomes desirable.&nbsp; =
|This memo presents such a human-</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; readable representation of time =
|specifications for the Schedule MIB.</FONT>
|</P>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Strauss&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Expires September 13, =
|2001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp; [Page 1]</FONT>
|</P>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Internet-Draft&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; Schedule MIB Time =
|Specs&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; March 2001</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>Table of Contents</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; 1. Introduction . . . . . . . . . . . . =
|. . . . . . . . . . . . . . 3</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; 2. Grammar and Semantics&nbsp; . . . . =
|. . . . . . . . . . . . . . . . . 3</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; 3. Examples . . . . . . . . . . . . . . =
|. . . . . . . . . . . . . . 5</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; 4. Security Considerations&nbsp; . . . =
|. . . . . . . . . . . . . . . . . 5</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; References . . . . . =
|. . . . . . . . . . . . . . . . . . . . . . 5</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Author's Address . . =
|. . . . . . . . . . . . . . . . . . . . . . 5</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; A. OPEN ISSUES&nbsp; . . . . . . . . . =
|. . . . . . . . . . . . . . . . . 6</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Full Copyright =
|Statement . . . . . . . . . . . . . . . . . . . . 7</FONT>
|</P>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Strauss&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Expires September 13, 2001&nbsp;&nbsp=
|;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
|; [Page 2]</FONT>
|</P>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Internet-Draft&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; Schedule MIB Time =
|Specs&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; March 2001</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>1. Introduction</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; The reader of this document is expected =
|to be familiar with the</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; Schedule MIB [RFC2591].</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; The Schedule MIB time specifications of =
|periodic and calendar/oneshot</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; schedule are stored in seven columnar =
|objects: schedType denotes the</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; type of the schedule, either periodic, =
|calendar or oneshot.</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; Depending on this value either the =
|schedInterval object is meaningful</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; in case of a periodic schedule, or the =
|five objects schedWeekDay,</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; schedMonth, schedDay, schedHour, and =
|schedMinute in case of calendar</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; and oneshot schedules.&nbsp; While this =
|is a reasonable and very flexible</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; way to express schedule time =
|specifications in the MIB, it is not</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; that convenient to use these seven =
|attributes when interacting with a</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; user.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; This document presents a simple grammar =
|for representing Schedule MIB</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; time specifications with the following =
|goals:</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; o&nbsp; Narrow Representation: In almost =
|any case, the representation of a</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; schedule time =
|specification shall take little space when presented</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; at a user =
|interface.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; o&nbsp; Handy Representation: The whole =
|specification should be more handy</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; than a collection of =
|six or seven attributes.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; o&nbsp; Human Readability: The =
|representation should be human readable.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; o&nbsp; Avoiding Typical =
|Misinterpretations: Typical mistakes that humans</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; run into should be =
|avoided by the representation, e.g.: when no</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; bits in one of the =
|calendar objects are set in the MIB, this means</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; that the schedule =
|gets never invoked.&nbsp; However when a user does</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; not specify a =
|calendar attribute, he usually wishes this attribute</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; to be a =
|`match-any'.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; o&nbsp; Implementation Costs: It should =
|be easy to implement a simple</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; parser that reads =
|time specifications entered by a user or read</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; from a =
|configuration.&nbsp; Similarly, it should be easy to render MIB</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; information according =
|to the proposed representation.</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>2. Grammar and Semantics</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Based on the goals described in the =
|former section, this memo</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; proposes to represent a schedule time =
|specification as a single</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; string that complies to the following =
|grammar:</FONT>
|</P>
|<BR>
|<BR>
|<BR>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Strauss&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Expires September 13, =
|2001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp; [Page 3]</FONT>
|</P>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Internet-Draft&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; Schedule MIB Time =
|Specs&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; March 2001</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; spec&nbsp;&nbsp;&nbsp; =3D =
|number | &quot;&quot; | &quot;*&quot; | list</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; list&nbsp;&nbsp;&nbsp; =3D =
|item [ &quot; &quot; item ]*</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; item&nbsp;&nbsp;&nbsp; =3D =
|start [ &quot;/&quot; step ] |</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp;&nbsp; range [ &quot;/&quot; step ]</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; start&nbsp;&nbsp; =3D witem =
|mitem ditem ritem Hitem Mitem</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; range&nbsp;&nbsp; =3D witem =
|&quot;-&quot; witem | mitem &quot;-&quot; mitem |</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp;&nbsp; ditem &quot;-&quot; ditem | ritem &quot;-&quot; =
|ritem |</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp;&nbsp; Hitem &quot;-&quot; Hitem | Mitem &quot;-&quot; =
|Mitem</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; step&nbsp;&nbsp;&nbsp; =3D =
|number</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; witem&nbsp;&nbsp; =3D =
|&quot;mon&quot; | &quot;tue&quot; | &quot;wed&quot; | &quot;thu&quot; =
||</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp;&nbsp; &quot;fri&quot; | &quot;sat&quot; | =
|&quot;sun&quot;</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; ditem&nbsp;&nbsp; =3D =
|&quot;d1&quot; .. &quot;d31&quot;</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; ritem&nbsp;&nbsp; =3D =
|&quot;r1&quot; .. &quot;r31&quot;</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; mitem&nbsp;&nbsp; =3D =
|&quot;jan&quot; | &quot;feb&quot; | &quot;mar&quot; | &quot;apr&quot; | =
|&quot;may&quot; | &quot;jun&quot; |</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp;&nbsp; &quot;jul&quot; | &quot;aug&quot; | =
|&quot;sep&quot; | &quot;oct&quot; | &quot;nov&quot; | =
|&quot;dec&quot;</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; Hitem&nbsp;&nbsp; =3D =
|&quot;h0&quot; .. &quot;h23&quot;</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; Mitem&nbsp;&nbsp; =3D =
|&quot;m0&quot; .. &quot;m59&quot;</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; A single (unsigned) integer number =
|specifies the interval of a</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; periodic schedule.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; An empty string specifies a =
|calendar/oneshot schedule that matches no</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; point in time.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; An &quot;*&quot; string specifies a =
|calendar/oneshot schedule that matches any</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; minute, i.e., all bits in the 5 BITS =
|objects are set (exception: not</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; all of the schedDay d*/r* bits have to =
|be set to achieve this).</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Any other string has to represent a list =
|of items separated by single</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; blanks.&nbsp; Each item has to consist =
|of a mandatory start value, an</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; optional end value (separated by `-') =
|and an optional step value</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; (separated by `/').&nbsp; Start and end =
|values can be weekdays, months,</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; `d-days', `r-days', hours, or minutes =
|and must be of the same type</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; and in low-high order when both are =
|present in a single item.&nbsp; Step</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; values are unsigned integers &gt;=3D =
|1.&nbsp; If an end value is given but no</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; step value, the step is 1.&nbsp; If a =
|step value is given but no end</FONT>
|</P>
|<BR>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Strauss&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Expires September 13, =
|2001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp; [Page 4]</FONT>
|</P>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Internet-Draft&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; Schedule MIB Time =
|Specs&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; March 2001</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; value, the end value is the last =
|possible value of the given type.</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; If both, end and step value, are =
|omitted, the item represents only a</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; single value.&nbsp; All letters in the =
|values are case-sensitive and must</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; be lowercase.&nbsp; No intermediate =
|blanks are allowed, except for</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; separating items.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Note that calendar and oneshot schedules =
|cannot be distinguished by</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; this grammar.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>3. Examples</FONT>
|</P>
|<BR>
|<BR>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; =
|&quot;&quot;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=
| never</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; =
|&quot;*&quot;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp=
|;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
|each and every minute</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; =
|&quot;30&quot;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbs=
|p;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
|periodically every 30 seconds</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; &quot;mon-fri h12 =
|m0&quot;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; each monday to =
|friday at 12 o'clock</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; &quot;mar/3 r1 h23 =
|m59&quot;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; each quarter's last day =
|at 23:59</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp; &quot;mon-fri/2 h8-18 =
|m0/30&quot;&nbsp; every 30 minutes from 8:00 to 18:30</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; on each monday, wednesday, and =
|friday</FONT>
|</P>
|<BR>
|<BR>
|
|<P><FONT SIZE=3D2>4. Security Considerations</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; This document defines a string =
|representation of schedule time</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; specifications which has no security =
|impact on the Internet.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>References</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; [RFC2591]&nbsp; Levi, D. and J. =
|Schoenwaelder, &quot;Definitions of Managed</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp; Objects for Scheduling Management Operations&quot;, RFC =
|2591,</FONT>
|<BR><FONT =
|SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nb=
|sp;&nbsp;&nbsp; May 1999.</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>Author's Address</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Frank Strauss</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; TU Braunschweig</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; Bueltenweg 74/75</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; 38106 Braunschweig</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; Germany</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Phone: +49 531 391-3266</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; EMail: [email-masked]</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; URI:&nbsp;&nbsp; <A =
|HREF=3D"http://www.ibr.cs.tu-bs.de/" =
|TARGET=3D"_blank">http://www.ibr.cs.tu-bs.de/</A></FONT>
|</P>
|<BR>
|<BR>
|<BR>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Strauss&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Expires September 13, =
|2001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp; [Page 5]</FONT>
|</P>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Internet-Draft&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; Schedule MIB Time =
|Specs&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; March 2001</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>Appendix A. OPEN ISSUES</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; 1.&nbsp; People might expect something =
|like &quot;mon-fri&quot; to fire _once_ each</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; workday?! =
|Should defaults for hour and minute be `0' instead of</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; `any' There =
|might be other intuitively varying situations.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; 2.&nbsp; Do we need a way to express =
|whether its a calendar or oneshot</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =
|schedule?</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; 3.&nbsp; Do we need words on error =
|handling?</FONT>
|</P>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Strauss&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Expires September 13, =
|2001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp; [Page 6]</FONT>
|</P>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Internet-Draft&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; Schedule MIB Time =
|Specs&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&=
|nbsp;&nbsp; March 2001</FONT>
|</P>
|<BR>
|
|<P><FONT SIZE=3D2>Full Copyright Statement</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Copyright (C) The Internet Society =
|(2001).&nbsp; All Rights Reserved.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; This document and translations of it may =
|be copied and furnished to</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; others, and derivative works that =
|comment on or otherwise explain it</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; or assist in its implementation may be =
|prepared, copied, published</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; and distributed, in whole or in part, =
|without restriction of any</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; kind, provided that the above copyright =
|notice and this paragraph are</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; included on all such copies and =
|derivative works.&nbsp; However, this</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; document itself may not be modified in =
|any way, such as by removing</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; the copyright notice or references to =
|the Internet Society or other</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; Internet organizations, except as =
|needed for the purpose of</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; developing Internet standards in which =
|case the procedures for</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; copyrights defined in the Internet =
|Standards process must be</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; followed, or as required to translate =
|it into languages other than</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; English.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; The limited permissions granted above =
|are perpetual and will not be</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; revoked by the Internet Society or its =
|successors or assigns.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; This document and the information =
|contained herein is provided on an</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; &quot;AS IS&quot; basis and THE =
|INTERNET SOCIETY AND THE INTERNET ENGINEERING</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; TASK FORCE DISCLAIMS ALL WARRANTIES, =
|EXPRESS OR IMPLIED, INCLUDING</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; BUT NOT LIMITED TO ANY WARRANTY THAT =
|THE USE OF THE INFORMATION</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; HEREIN WILL NOT INFRINGE ANY RIGHTS OR =
|ANY IMPLIED WARRANTIES OF</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; MERCHANTABILITY OR FITNESS FOR A =
|PARTICULAR PURPOSE.</FONT>
|</P>
|
|<P><FONT SIZE=3D2>Acknowledgement</FONT>
|</P>
|
|<P><FONT SIZE=3D2>&nbsp;&nbsp; Funding for the RFC Editor function is =
|currently provided by the</FONT>
|<BR><FONT SIZE=3D2>&nbsp;&nbsp; Internet Society.</FONT>
|</P>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|<BR>
|
|<P><FONT =
|SIZE=3D2>Strauss&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Expires September 13, =
|2001&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n=
|bsp;&nbsp;&nbsp; [Page 7]</FONT>
|</P>
|<BR>
|
|</BODY>
|</HTML>
|------_=_NextPart_001_01C0B865.2802136A--
|

 -------------------------------------------------------
 Randy Presuhn           [email-masked]
 Voice: +1 408 546-1006  BMC Software, Inc.  1-3141
 Fax:   +1 408 965-0359  2141 North First Street
 http://www.bmc.com/     San José, California 95131  USA
 -------------------------------------------------------
 My opinions and BMC's are independent variables.
 -------------------------------------------------------